#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<cmath>
#include <queue>
#include<algorithm>
using namespace std;

void bfs(const vector<vector<int> > & sons, const vector<int> & pars, int root, vector<int> & res){
  int counter = 0;
  queue<int> q;
  q.push(root);
  while(!q.empty()){
    int next = q.front();
    q.pop();
    res[next] = counter++;
    for(int i=0; i<sons[next].size(); ++i){
      q.push(sons[next][i]);
    }
  }
}

void dfs(const vector<vector<int> > & sons, const vector<int> & pars, const vector<int> & order, int root, vector<int> & res){
  res.push_back(order[root]);
  for(int i=0; i<sons[root].size(); ++i){
    dfs(sons, pars, order, sons[root][i], res);
    res.push_back(order[root]);
  }
}

template <typename T>
class SegmentTree {
  private:
    std::vector<T> data;
    size_t size;
  public:
    SegmentTree(): size(0) {}
    SegmentTree(const std::vector<T> &A)
    {
      size_t size = 1;
      while (size < A.size()) size <<= 1;
      data.resize(size << 1);
      copy(A.begin(), A.end(), data.begin() + size);
      for (size_t i = size - 1; i > 0; --i)
        data[i] = min(data[2*i], data[2*i + 1]);
    }
    T & operator[](size_t i)
    {
      return data[data.size() / 2 + i];
    }
    T & root() {
      return data[1];
    }
    inline T query(size_t i, size_t j) const
    {
      i += data.size() / 2;
      j += data.size() / 2 - 1;


    }
};

int main() {
  int N;
  while(cin >> N){
    vector<vector<int> > sons(N);
    vector<int> pars(N);
    pars[0] = -1;
    int k;
    for(int i=1; i<N; ++i){
      cin >> k;
      sons[k].push_back(i);
      pars[i] = k;
    }

    vector<int> order(N);
    bfs(sons, pars, 0, order);

    vector<int> res;
    dfs(sons, pars, order, 0, res);
    for(int i=0; i<order.size(); ++i){
      cout << order[i] << ", ";
    }
    cout << '\n';
    for(int i=0; i<res.size(); ++i){
      cout << res[i] << ", ";
    }
    cout << '\n';
  }

  return 0;
}
